/**
 * Global variables
 */

var currentDay; // Day
var currentMonth; // Month
var currentYear; // Year
var startMonthDay // Start Day of the Current Month

/**
 * Initialization function
 * @param {Object} - a date object
 */
function init(day){
  var today;
  // If no date is passed, 
  // use current system date
  if (day == null) 
    today = new Date();
  else 
    today = day;
  currentDay = today.getDate();
  currentMonth = today.getMonth();
  currentYear = today.getFullYear();
  var startMonth = 
  	new Date(currentYear, currentMonth, 1);
  startMonthDay = startMonth.getDay();
  if (startMonthDay == 0) 
    startMonthDay = 7;
}

/**
 * Generate 6 rows with 7 columns each
 * Last row to have class
 */
function row(){
  var z = $("<tr></tr>");
  for (var i = 0; i < 7; i++) {
    if (i == 6) 
      z.append($("<td></td>").addClass("sunday"));
    else 
      z.append($("<td></td>"));
  }
  return z;
}

/**
 * Generate adapted days in table
 * @param {Object} startMonthDay
 */
function days(startMonthDay){
  for (var i = 0; i < 42; i++) {
    $("td").eq(i).append(
    	new Date(currentYear, currentMonth, 
    		i - startMonthDay + 2).getDate());
  }
}

/**
 * The ready method
 */
$(function(){
  // Either pass current day date
  // or any date
  init(new Date());
  // Table header rows
  $("table").append(
  	$("<tr><th>Mon</th><th>Tue</th><th>Wed</th>" +
  		"<th>Thu</th><th>Fri</th>" + 
  		"<th>Sat</th><th>Sun</th></tr>"));
  // Append 6 rows with 7 columns each
  for (var j = 0; j < 6; j++) {
    $("table").append(row());
  }
  // Fill rows depending on start day
  days(startMonthDay);
  // Format TH lines
  $("th").addClass("headercells");
  // Format odd line numbers
  $("tr:odd").addClass("odd");
  // All TD cells before start of month transparent
  $("td").slice(0, startMonthDay - 1).css(
  	"opacity", "0.3");
  // All TD lines after end of month transparent
  for (i = 28; i < 42; i++) {
    if ($("td").eq(i).html() < 15) 
      $("td").eq(i).css("opacity", "0.3");
  }
  // Format the current day
  $("td").eq(currentDay + startMonthDay - 2).
  	addClass("currentDay");
  // Output month and year
  $("div:first").append(
  	(currentMonth + 1) + "/" + currentYear);
});


